﻿Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Net
Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Documents
Imports System.Windows.Input
Imports System.Windows.Media
Imports System.Windows.Media.Animation
Imports System.Windows.Shapes

Partial Public Class MainPage
    Inherits UserControl
    Private Enum animationState
        Stopped
        Running
        Paused
    End Enum
    Private runningX As animationState = animationState.Stopped
    Private runningY As animationState = animationState.Stopped
    Private runningZ As animationState = animationState.Stopped


    Private pt As Point
    Public Sub New()
        InitializeComponent()
        AddHandler Loaded, AddressOf MainPage_Loaded

    End Sub

    Private Sub MainPage_Loaded(ByVal sender As Object, ByVal e As RoutedEventArgs)
        resetSlide()
    End Sub
    Private Sub resetSlide()
        storyboardRotateX.Stop()
        storyboardRotateY.Stop()
        storyboardRotateZ.Stop()

        projectionFront.RotationY = 30
        projectionBottom.RotationY = 30
        projectionBack.RotationY = 30
        projectionTop.RotationY = 30
        'projRight.RotationY = -90 + 30;
        'projLeft.RotationY = -270+ 30;
        sliderY.Value = 0
        sliderZ.Value = 125

        runningZ = animationState.Stopped
        runningY = runningZ
        runningX = runningY
        rotateX.Content = "Rotate X"
        rotateY.Content = "Rotate Y"
        rotateZ.Content = "Rotate Z"

        If storyboardRotateX.GetCurrentState() = ClockState.Active Then
            storyboardRotateX.Stop()
        End If
        If storyboardRotateY.GetCurrentState() = ClockState.Active Then
            storyboardRotateY.Stop()
        End If
        If storyboardRotateZ.GetCurrentState() = ClockState.Active Then
            storyboardRotateZ.Stop()
        End If

    End Sub
    Private Sub sliderY_ValueChanged(ByVal sender As Object, ByVal e As RoutedPropertyChangedEventArgs(Of Double))
        pt = New Point(e.NewValue, 100)

        Try
            projectionFront.RotationY += pt.X
            projectionBottom.RotationY += pt.X
            projectionBack.RotationY += pt.X
            projectionTop.RotationY += pt.X
            ' projRight.RotationY += pt.X;
            ' projLeft.RotationY += pt.X;
            ToolTipService.SetToolTip(sliderY, pt.X.ToString())
            'rectprojectionFront.Fill

            Dim colorValueA As String = "00" ' - pt.X).ToString();
            Dim colorValueR As String = "00"
            Dim colorValueG As String = "FF"
            Dim colorValueB As String = "00"

            Dim cValueA As String = ConvertHex(colorValueA)
            Dim cValueR As String = ConvertHex(colorValueR)
            Dim cValueG As String = ConvertHex(colorValueG)
            Dim cValueB As String = ConvertHex(colorValueB)

            Dim colorValue As String = cValueA & cValueR & cValueG & cValueB
            ' rectprojectionFront.Fill = new SolidColorBrush(getColorFromHex(colorValue));


        Catch e1 As Exception
        End Try
    End Sub
    Private Function ConvertHex(ByVal s As String) As String
        Dim rHex As String = s
        If s = "10" Then
            rHex = "AA"
        End If
        If s = "11" Then
            rHex = "BB"
        End If
        If s = "12" Then
            rHex = "CC"
        End If
        If s = "13" Then
            rHex = "DD"
        End If
        If s = "14" Then
            rHex = "EE"
        End If
        If s = "15" Then
            rHex = "FF"
        End If

        Return rHex
    End Function
    Public Function getColorFromHex(ByVal s As String) As Color
        Dim a As Byte = System.Convert.ToByte(s.Substring(0, 2), 16)
        Dim r As Byte = System.Convert.ToByte(s.Substring(2, 2), 16)
        Dim g As Byte = System.Convert.ToByte(s.Substring(4, 2), 16)
        Dim b As Byte = System.Convert.ToByte(s.Substring(6, 2), 16)
        Return Color.FromArgb(a, r, g, b)
    End Function
    Private Sub Light_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
        If BulbGradient.Visibility = System.Windows.Visibility.Collapsed Then
            BulbGradient.Visibility = System.Windows.Visibility.Visible
            bgImage.Visibility = System.Windows.Visibility.Collapsed
            btnLight.Content = "Background"
        Else
            BulbGradient.Visibility = System.Windows.Visibility.Collapsed
            bgImage.Visibility = System.Windows.Visibility.Visible
            btnLight.Content = "Light"
        End If
    End Sub
    Private Sub RotateX_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
        If runningX = animationState.Running Then
            storyboardRotateX.Pause()
            runningX = animationState.Paused
            rotateX.Content = "Rotate X"

        ElseIf runningX = animationState.Paused Then
            storyboardRotateX.Resume()
            runningX = animationState.Running
            rotateX.Content = "Pause X"
        ElseIf runningX = animationState.Stopped Then
            storyboardRotateX.Begin()
            runningX = animationState.Running
            rotateX.Content = "Pause X"
        End If

    End Sub
    Private Sub RotateY_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
        If runningY = animationState.Running Then
            storyboardRotateY.Pause()
            runningY = animationState.Paused
            rotateY.Content = "Rotate Y"

        ElseIf runningY = animationState.Paused Then
            storyboardRotateY.Resume()
            runningY = animationState.Running
            rotateY.Content = "Pause Y"
        ElseIf runningY = animationState.Stopped Then
            storyboardRotateY.Begin()
            runningY = animationState.Running
            rotateY.Content = "Pause Y"
        End If
    End Sub
    Private Sub RotateZ_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
        If runningZ = animationState.Running Then
            storyboardRotateZ.Pause()
            runningZ = animationState.Paused
            rotateZ.Content = "Rotate Z"
        ElseIf runningZ = animationState.Paused Then
            storyboardRotateZ.Resume()
            runningZ = animationState.Running
            rotateZ.Content = "Pause Z"
        ElseIf runningZ = animationState.Stopped Then
            storyboardRotateZ.Begin()
            runningZ = animationState.Running
            rotateZ.Content = "Pause Z"
        End If
    End Sub
    Private Sub Reset_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
        resetSlide()
    End Sub
    Private Sub Pause_Animation(ByVal sender As Object, ByVal e As MouseButtonEventArgs)
        If runningY = animationState.Running Then
            storyboardRotateY.Pause()
            runningY = animationState.Paused
            rotateY.Content = "Rotate Y"
        ElseIf runningY = animationState.Paused Then
            storyboardRotateY.Resume()
            runningY = animationState.Running
            rotateY.Content = "Pause Y"
        End If

        If runningZ = animationState.Running Then
            storyboardRotateZ.Pause()
            runningZ = animationState.Paused
            rotateZ.Content = "Rotate Z"

        ElseIf runningZ = animationState.Paused Then
            storyboardRotateZ.Resume()
            runningZ = animationState.Running
            rotateZ.Content = "Pause Z"

        End If
    End Sub

    Private Sub sliderZ_ValueChanged(ByVal sender As Object, ByVal e As RoutedPropertyChangedEventArgs(Of Double))

        Try
            projectionTop.CenterOfRotationZ = e.NewValue
            projectionBack.CenterOfRotationZ = projectionTop.CenterOfRotationZ
            projectionBottom.CenterOfRotationZ = projectionBack.CenterOfRotationZ
            projectionFront.CenterOfRotationZ = projectionBottom.CenterOfRotationZ
            ToolTipService.SetToolTip(sliderZ, e.NewValue.ToString())
        Catch e1 As Exception
        End Try
    End Sub
End Class