﻿<!--<UserControl x:Class="PerspectiveTransformsSliderDemo.Page"
    xmlns="http://schemas.microsoft.com/winfx/2006/xaml/presentation"
    xmlns:x="http://schemas.microsoft.com/winfx/2006/xaml"
    xmlns:local="clr-namespace:PerspectiveTransformsSliderDemo">
  <UserControl.Resources>
    --><!--<local:RoundOffConverter x:Key="Converter1"/>--><!--
  </UserControl.Resources>
  <Grid x:Name="LayoutRoot" Background="LightBlue" Width="600" Height="530">
    <Grid.Resources>
      <Style TargetType="Slider" x:Name="SliderStyle">
        <Setter Property="Margin" Value="2" />
      </Style>
      <Style TargetType="TextBlock" x:Name="PropTextBlockStyle">
        <Setter Property="Margin" Value="3" />
        <Setter Property="FontWeight" Value="Bold" />
      </Style>

    </Grid.Resources>
    <Grid.RowDefinitions>
      <RowDefinition Height="350" />
      <RowDefinition Height="Auto" />
    </Grid.RowDefinitions>

    <Border Canvas.ZIndex="1" Background="Yellow" Width="400" Height="300" BorderBrush="Black" BorderThickness="5">
      <Border.Projection>
        <PlaneProjection x:Name="projection1" />
      </Border.Projection>
      <Grid>
        <Grid.RowDefinitions>
          <RowDefinition />
          <RowDefinition Height="50" />
        </Grid.RowDefinitions>
        <TextBlock Text="Perspective Transform" FontSize="24" Margin="5"  />

        <Grid HorizontalAlignment="Left" Margin="10,50">
          <Grid.ColumnDefinitions>
            <ColumnDefinition Width="110" />
            <ColumnDefinition Width="55" />
            <ColumnDefinition Width="30" />
            <ColumnDefinition Width="110" />
            <ColumnDefinition Width="55" />
          </Grid.ColumnDefinitions>
          <Grid.RowDefinitions>
            <RowDefinition Height="25" />
            <RowDefinition Height="25" />
            <RowDefinition Height="25" />
            <RowDefinition Height="25" />
            <RowDefinition Height="25" />
            <RowDefinition Height="25" />
            <RowDefinition Height="25" />
          </Grid.RowDefinitions>
          <TextBlock Grid.Column="0" Grid.Row="0" Text="RotationX" />
          <TextBlock Style="{StaticResource PropTextBlockStyle}" Text="{Binding ElementName=projection1, Path=RotationX, Mode=OneWay, Converter={StaticResource Converter1}}" Grid.Column="1" Grid.Row="0"/>

          <TextBlock Grid.Column="0" Grid.Row="1" Text="RotationY" />
          <TextBlock Style="{StaticResource PropTextBlockStyle}" Text="{Binding ElementName=projection1, Path=RotationY, Mode=OneWay, Converter={StaticResource Converter1}}" Grid.Column="1" Grid.Row="1"/>

          <TextBlock Grid.Column="0" Grid.Row="2" Text="RotationZ" />
          <TextBlock Style="{StaticResource PropTextBlockStyle}" Text="{Binding ElementName=projection1, Path=RotationZ, Mode=OneWay, Converter={StaticResource Converter1}}" Grid.Column="1" Grid.Row="2"/>

          <TextBlock Grid.Column="0" Grid.Row="3" Text="CenterOfRotationX" />
          <TextBlock Style="{StaticResource PropTextBlockStyle}" Text="{Binding ElementName=projection1, Path=CenterOfRotationX, Mode=OneWay, Converter={StaticResource Converter1}}" Grid.Column="1" Grid.Row="3"/>

          <TextBlock Grid.Column="0" Grid.Row="4" Text="CenterOfRotationY" />
          <TextBlock Style="{StaticResource PropTextBlockStyle}" Text="{Binding ElementName=projection1, Path=CenterOfRotationY, Mode=OneWay, Converter={StaticResource Converter1}}" Grid.Column="1" Grid.Row="4"/>

          <TextBlock Grid.Column="0" Grid.Row="5" Text="CenterOfRotationZ" />
          <TextBlock Style="{StaticResource PropTextBlockStyle}" Text="{Binding ElementName=projection1, Path=CenterOfRotationZ, Mode=OneWay, Converter={StaticResource Converter1}}" Grid.Column="1" Grid.Row="5"/>

          <TextBlock Grid.Column="3" Grid.Row="0" Text="LocalOffsetX" />
          <TextBlock Style="{StaticResource PropTextBlockStyle}" Text="{Binding ElementName=projection1, Path=LocalOffsetX, Mode=OneWay, Converter={StaticResource Converter1}}" Grid.Column="4" Grid.Row="0"/>

          <TextBlock Grid.Column="3" Grid.Row="1" Text="LocalOffsetY" />
          <TextBlock Style="{StaticResource PropTextBlockStyle}" Text="{Binding ElementName=projection1, Path=LocalOffsetY, Mode=OneWay, Converter={StaticResource Converter1}}" Grid.Column="4" Grid.Row="1"/>

          <TextBlock Grid.Column="3" Grid.Row="2" Text="LocalOffsetZ" />
          <TextBlock Style="{StaticResource PropTextBlockStyle}" Text="{Binding ElementName=projection1, Path=LocalOffsetZ, Mode=OneWay, Converter={StaticResource Converter1}}" Grid.Column="4" Grid.Row="2"/>

          <TextBlock Grid.Column="3" Grid.Row="3" Text="GlobalOffsetX" />
          <TextBlock Style="{StaticResource PropTextBlockStyle}" Text="{Binding ElementName=projection1, Path=GlobalOffsetX, Mode=OneWay, Converter={StaticResource Converter1}}" Grid.Column="4" Grid.Row="3"/>

          <TextBlock Grid.Column="3" Grid.Row="4" Text="GlobalOffsetY" />
          <TextBlock Style="{StaticResource PropTextBlockStyle}" Text="{Binding ElementName=projection1, Path=GlobalOffsetY, Mode=OneWay, Converter={StaticResource Converter1}}" Grid.Column="4" Grid.Row="4"/>

          <TextBlock Grid.Column="3" Grid.Row="5" Text="GlobalOffsetZ" />
          <TextBlock Style="{StaticResource PropTextBlockStyle}" Text="{Binding ElementName=projection1, Path=GlobalOffsetZ, Mode=OneWay, Converter={StaticResource Converter1}}" Grid.Column="4" Grid.Row="5"/>
        </Grid>
        <ComboBox Grid.ColumnSpan="2" Width="200" Grid.Row="1" VerticalAlignment="Top" >
          <ComboBoxItem Content="Sample Item 1" IsSelected="True"  />
          <ComboBoxItem Content="Sample Item 2" />
          <ComboBoxItem Content="Sample Item 3" />
          <ComboBoxItem Content="Sample Item 4" />
          <ComboBoxItem Content="Sample Item 5" />
        </ComboBox>
        <Button Grid.Column="1" Grid.Row="1" Content="Reset" VerticalAlignment="Bottom" HorizontalAlignment="Right" Click="Button_Click" Margin="5" />
      </Grid>
    </Border>

    <Grid Grid.Row="1" >
      <Grid.ColumnDefinitions>
        <ColumnDefinition Width="150" />
        <ColumnDefinition Width="130" />
        <ColumnDefinition Width="130" />
        <ColumnDefinition Width="130" />
      </Grid.ColumnDefinitions>
      <Grid.RowDefinitions>
        <RowDefinition Height="Auto" />
        <RowDefinition Height="Auto" />
        <RowDefinition Height="Auto" />
        <RowDefinition Height="Auto" />
        <RowDefinition Height="Auto" />
      </Grid.RowDefinitions>

      <TextBlock Grid.Row="1" FontSize="14" FontWeight="Bold" Text="Rotation" Margin="5" />
      <TextBlock Grid.Row="2" FontSize="14" FontWeight="Bold" Text="CenterOfRotation" Margin="5" />
      <TextBlock Grid.Row="3" FontSize="14" FontWeight="Bold" Text="LocalOffset" Margin="5" />
      <TextBlock Grid.Row="4" FontSize="14" FontWeight="Bold" Text="GlobalOffset" Margin="5" />

      <TextBlock Grid.Column="1" FontSize="18" Text="X" Margin="5" HorizontalAlignment="Center" />
      <TextBlock Grid.Column="2" FontSize="18" Text="Y" Margin="5" HorizontalAlignment="Center" />
      <TextBlock Grid.Column="3" FontSize="18" Text="Z" Margin="5" HorizontalAlignment="Center" />

      <Slider Grid.Row="1" Grid.Column="1" Style="{StaticResource SliderStyle}" Minimum="-180" Maximum="180" Value="{Binding ElementName=projection1, Path=RotationX, Mode=TwoWay}" ToolTipService.ToolTip="{Binding ElementName=projection1, Path=RotationX, Mode=TwoWay}" />
      <Slider Grid.Row="1" Grid.Column="2" Style="{StaticResource SliderStyle}" Minimum="-180" Maximum="180" Value="{Binding ElementName=projection1, Path=RotationY, Mode=TwoWay}" ToolTipService.ToolTip="{Binding ElementName=projection1, Path=RotationY, Mode=TwoWay}" />
      <Slider Grid.Row="1" Grid.Column="3" Style="{StaticResource SliderStyle}" Minimum="-180" Maximum="180" Value="{Binding ElementName=projection1, Path=RotationZ, Mode=TwoWay}" ToolTipService.ToolTip="{Binding ElementName=projection1, Path=RotationZ, Mode=TwoWay}" />

      <Slider Grid.Row="2" Grid.Column="1" Style="{StaticResource SliderStyle}" Minimum="0" Maximum="1" Value="{Binding ElementName=projection1, Path=CenterOfRotationX, Mode=TwoWay}" ToolTipService.ToolTip="{Binding ElementName=projection1, Path=CenterOfRotationX, Mode=TwoWay}" />
      <Slider Grid.Row="2" Grid.Column="2" Style="{StaticResource SliderStyle}" Minimum="0" Maximum="1" Value="{Binding ElementName=projection1, Path=CenterOfRotationY, Mode=TwoWay}" ToolTipService.ToolTip="{Binding ElementName=projection1, Path=CenterOfRotationY, Mode=TwoWay}" />
      <Slider Grid.Row="2" Grid.Column="3" Style="{StaticResource SliderStyle}" Minimum="-300" Maximum="300" Value="{Binding ElementName=projection1, Path=CenterOfRotationZ, Mode=TwoWay}" ToolTipService.ToolTip="{Binding ElementName=projection1, Path=CenterOfRotationZ, Mode=TwoWay}" />

      <Slider Grid.Row="3" Grid.Column="1" Style="{StaticResource SliderStyle}" Minimum="-200" Maximum="200" Value="{Binding ElementName=projection1, Path=LocalOffsetX, Mode=TwoWay}" ToolTipService.ToolTip="{Binding ElementName=projection1, Path=LocalOffsetX, Mode=TwoWay}" />
      <Slider Grid.Row="3" Grid.Column="2" Style="{StaticResource SliderStyle}" Minimum="-200" Maximum="200" Value="{Binding ElementName=projection1, Path=LocalOffsetY, Mode=TwoWay}" ToolTipService.ToolTip="{Binding ElementName=projection1, Path=LocalOffsetY, Mode=TwoWay}" />
      <Slider Grid.Row="3" Grid.Column="3" Style="{StaticResource SliderStyle}" Minimum="-200" Maximum="200" Value="{Binding ElementName=projection1, Path=LocalOffsetZ, Mode=TwoWay}" ToolTipService.ToolTip="{Binding ElementName=projection1, Path=LocalOffsetZ, Mode=TwoWay}" />

      <Slider Grid.Row="4" Grid.Column="1" Style="{StaticResource SliderStyle}" Minimum="-200" Maximum="200" Value="{Binding ElementName=projection1, Path=GlobalOffsetX, Mode=TwoWay}" ToolTipService.ToolTip="{Binding ElementName=projection1, Path=GlobalOffsetX, Mode=TwoWay}" />
      <Slider Grid.Row="4" Grid.Column="2" Style="{StaticResource SliderStyle}" Minimum="-200" Maximum="200" Value="{Binding ElementName=projection1, Path=GlobalOffsetY, Mode=TwoWay}" ToolTipService.ToolTip="{Binding ElementName=projection1, Path=GlobalOffsetY, Mode=TwoWay}" />
      <Slider Grid.Row="4" Grid.Column="3" Style="{StaticResource SliderStyle}" Minimum="-200" Maximum="200" Value="{Binding ElementName=projection1, Path=GlobalOffsetZ, Mode=TwoWay}" ToolTipService.ToolTip="{Binding ElementName=projection1, Path=GlobalOffsetZ, Mode=TwoWay}" />
    </Grid>
  </Grid>
</UserControl>-->
