﻿Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Net
Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Documents
Imports System.Windows.Input
Imports System.Windows.Media
Imports System.Windows.Media.Animation
Imports System.Windows.Shapes
Imports System.Windows.Threading
Imports System.Windows.Media.Imaging

Partial Public Class MainPage
    Inherits UserControl
    Private currentImageIndex As Integer = 1
    Private axis As String = "x"
    Private timer As New DispatcherTimer()
    Private cubeXAxis As Boolean
    Private cubeYAxis As Boolean
    Private cubeZAxis As Boolean

    Public Sub New()
        InitializeComponent()
        timer.Interval = New TimeSpan(0, 0, 0, 0, 500)
        AddHandler timer.Tick, AddressOf Tick
    End Sub
    Private Sub Tick(ByVal o As Object, ByVal sender As EventArgs)
        Dim imageuri As String = "cube/" & axis & "/" & currentImageIndex & ".png"
        bgImage.Source = New BitmapImage(New Uri(imageuri, UriKind.RelativeOrAbsolute))
        If currentImageIndex <= 8 Then
            currentImageIndex += 1
        Else
            currentImageIndex = 1
        End If
    End Sub
    Private Sub RotateX_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
        axis = "x"
        currentImageIndex = 1
        cubeXAxis = Not cubeXAxis
        If cubeXAxis Then
            btnRotateX.Content = "Pause X"
            timer.Start()
        Else
            btnRotateX.Content = "Rotate X"
            timer.Stop()
        End If
    End Sub
    Private Sub sliderX_ValueChanged(ByVal sender As Object, ByVal e As RoutedPropertyChangedEventArgs(Of Double))
        currentImageIndex = Math.Abs(CInt(Fix(e.NewValue)))
        timer.Stop()
        Dim imageuri As String = "cube/" & axis & "/" & currentImageIndex & ".png"
        bgImage.Source = New BitmapImage(New Uri(imageuri, UriKind.RelativeOrAbsolute))
    End Sub

    Private Sub RotateY_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
        axis = "y"
        currentImageIndex = 1
        cubeYAxis = Not cubeYAxis
        If cubeYAxis Then
            btnRotateY.Content = "Pause Y"
            timer.Start()
        Else
            btnRotateY.Content = "Rotate Y"
            timer.Stop()
        End If
    End Sub

    Private Sub RotateZ_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
        axis = "z"
        currentImageIndex = 1
        cubeZAxis = Not cubeZAxis
        If cubeZAxis Then
            btnRotateZ.Content = "Pause Z"
            timer.Start()
        Else
            btnRotateZ.Content = "Rotate Z"
            timer.Stop()
        End If
    End Sub
    Private Sub Reset_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
        timer.Stop()
        currentImageIndex = 1
        axis = "x"
        Dim imageuri As String = "cube/" & axis & "/" & currentImageIndex & ".png"
        bgImage.Source = New BitmapImage(New Uri(imageuri, UriKind.RelativeOrAbsolute))

    End Sub
End Class
